export interface MemoizeOptions<A extends unknown[], R> {
    /**
     * Provides a single value to use as the Key for the memoization.
     * Defaults to `JSON.stringify` (ish).
     */
    hash?: (...args: A) => unknown;
    /**
     * The Cache implementation to provide. Must be a Map or Map-alike.
     * Defaults to a Map. Useful for replacing the cache with an LRU cache or similar.
     */
    cache?: Map<unknown, R>;
}
export declare type MemoizableFunction<A extends unknown[], R extends unknown, T extends unknown> = (this: T, ...args: A) => R;
export declare function defaultHash(...args: unknown[]): string;
export default function memoize<A extends unknown[], R extends unknown, T extends unknown>(fn: MemoizableFunction<A, R, T>, opts?: MemoizeOptions<A, R>): MemoizableFunction<A, R, T>;
//# sourceMappingURL=index.d.ts.map